--------------------------------------------------------------------------------
-- Weapon Stoning + Projectile Stone
-- Original Carnage Contest Weapon
-- Script by DC, September 2009, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.piano={}
cc.piano.piano={}

-- Load & Prepare Ressources
cc.piano.gfx_pro=loadgfx("weapons/Piano.bmp")					-- Projectile Image
setmidhandle(cc.piano.gfx_pro)
cc.piano.gfx_col=loadgfx("weapons/Piano_collision.bmp")					-- Projectile Image
setmidhandle(cc.piano.gfx_col)
cc.piano.gfx_pro2=loadgfx("weapons/Piano_closed.bmp")
setmidhandle(cc.piano.gfx_pro2)
cc.piano.sfx_hit=loadsfx("pianofall.ogg")

--------------------------------------------------------------------------------
-- Weapon: Stoning
--------------------------------------------------------------------------------

cc.piano.id=addweapon("cc.piano","Piano",cc.piano.gfx_pro,0,3)	-- Add Weapon (0 uses, first in round 3)

function cc.piano.draw()											-- Draw
	-- HUD Positioning
	if weapon_shots==0 then
		hudpositioning(pos_invisible)
	end
end

function cc.piano.attack(attack)									-- Attack
	if (weapon_shots<=0) and (weapon_position==1) then
		-- No more weapon switching!
		useweapon(0)
		weapon_shots=weapon_shots+1
		weapon_position=0
		-- Spawn 1 piano (2 pianos? xD)
		--for i=1,5,1 do
			pid=createprojectile(cc.piano.piano.id)
			projectiles[pid]={}
			projectiles[pid].x=weapon_x
			projectiles[pid].y=-350
			projectiles[pid].sy=10
			projectiles[pid].timer=2 --i*25
		--end
		-- End Turn
		endturn()
	end
end

--------------------------------------------------------------------------------
-- Projectile: Stone
--------------------------------------------------------------------------------

cc.piano.piano.id=addprojectile("cc.piano.piano")		-- Add Projectile

function cc.piano.piano.draw(id)							-- Draw
	if projectiles[id].timer<=0 then
		-- Stone
		setcolor(255,255,255)
		setblend(blend_alpha)
		setalpha(1)
		setrotation(0)
		drawimage(cc.piano.gfx_pro,projectiles[id].x,projectiles[id].y)
	end
end

function cc.piano.piano.update(id)						-- Update
	-- Timer
	if projectiles[id].timer>0 then
		-- Count Down before stone appears
		projectiles[id].timer=projectiles[id].timer-1
	else
		-- Stone appears
		-- Particle Tail
		particle(p_smoke,projectiles[id].x+math.random(-6,6),projectiles[id].y-7)
		particlespeed(math.random(-2,2)*0.1,math.random(-2,2)*0.1)
		particlefadealpha(0.05)
		-- Move (in substep loop for optimal collision precision)
		msubt=math.abs((projectiles[id].sy)/2)
		msuby=projectiles[id].sy/msubt
		for i=1,msubt,1 do
			projectiles[id].y=projectiles[id].y+msuby
			-- Collision
			if collision(cc.piano.gfx_col,projectiles[id].x,projectiles[id].y,1,1)==1 then
				-- Player Damage
				if playercollision()~=0 then
					playerdamage(playercollision(),getplayerhealth(playercollision()))
				end
				if terraincollision()==1 then
					-- Impact
					playsound(cc.piano.sfx_hit)
					terrainbackimage(cc.piano.gfx_pro2,projectiles[id].x,projectiles[id].y)
					for angle=0,340,20 do
						particle(p_smoke,projectiles[id].x,projectiles[id].y)
						particlespeed(math.sin(math.rad(angle))*20,-math.cos(math.rad(angle))*20)
						particlecolor(150,150,150)
					end
					-- Free projectile
					freeprojectile(id)
					break
				end
			end
			-- Water
			if (projectiles[id].y)>getwatery()+5 then
				-- Effects
				particle(p_waterhit,projectiles[id].x,projectiles[id].y)
				particlesize(1.5,2.0)
				playsound(sfx_hitwater4)
				-- Free projectile
				freeprojectile(id)
				break
			end
		end
	end
end